Subject: Re: [PATCH v8 01/29] thermal/core: Add a generic thermal_zone_get_trip() function

From: Ido Schimmel <[email-masked]>
Date: Mon, 13 Mar 2023 14:12:44 +0200

On Mon, Mar 13, 2023 at 11:45:41AM +0100, Daniel Lezcano wrote:
> Thanks for reporting this, I think the fix you are proposing is correct
> regarding the previous behavior.
> 
> However, I disagree with the commit 81ad4276b505, because it defines the
> zero as an invalid trip point. But some platforms have warming devices, when
> the temperature is too cold, eg 0°C, we enable the warming device in order
> to stay in the functioning temperature range.
> 
> Other devices can do the same with negative temperature values.
> 
> This feature is not yet upstream and the rework of the trip point should
> allow proper handling of cold trip points.
> 
> If you can send the change to fix the regression that would be great.

Thanks for the reply. Will send you the fix later this week. I want to
test it across all of our systems.

> 
> But keep in mind, the driver is assuming an internal thermal framework
> behavior. The trips_disabled is only to overcome a trip point description
> bug and you should not rely on it as well as not changing the trip points on
> the fly after they are registered.
> 
> Actually, the mlxsw driver should just build a valid array of trip points
> without 0°C trip point and pass it to
> thermal_zone_device_register_with_trips(). That would be a proper change
> without relying on a side effect of the thermal trip bug 0°C workaround.

Understood. Will check with Vadim what we can do in order not to rely on
this behavior.